<?php
/**	ARA Build RSS
	(c) 2007-2014 Denis Sureau - Scriptol.com
	Licence GNU GPL 2.
*/
session_start(); 
	
include_once("ara-authorize.php");
include_once("ara-class.php");

if (isset( $_POST ))
	$posted=&$_POST;			
else
	$posted=&$HTTP_POST_VARS;

if(array_key_exists('login', $_SESSION))
	$ulogin=$_SESSION["login"];
else
  $ulogin=$posted["login"];  
if(array_key_exists('password', $_SESSION))	
	$upass=$_SESSION["password"];
else
  $upass=$posted["password"]; 
   
if(array_key_exists('registered', $_SESSION))
	$registered=$_SESSION["registered"];
else
  $registered= authorize($ulogin, $upass); 
	
$unwanted   = array("\r\n", "\n", "\r", "\t", "  ");  // char to replace

function logMessage($message)
{
	$fp = fopen("ara.log", 'a'); 
	fwrite($fp, $message);
	fclose($fp);
}	

function araMessage($message)
{
	$fp = fopen("ara-build-result.txt", 'w'); 
	fwrite($fp, $message);
	fclose($fp); 
}

unlink("ara.log");

if(!$registered) 
{
	araMessage("User $ulogin not registered." . $_SESSION['login']);
	die("You must be registered to use this software.");
}

logMessage("Registered\n");
logMessage("Starting...\n"); 
  
$fp = fopen("ara-build-result.txt", 'w'); 
if($fp == false)
	die("Enable to open file for writing...");
if(fwrite($fp, "error") === false)
	die("Enable to write...");
fclose($fp); 


	$feed =  $posted["feed"];
	$title = urldecode($posted["title"]);
	$link = urldecode($posted["link"]);
	$desc = $posted["description"];
	$date = $posted["date"];
	$type = $posted["type"];

	$ext = "";
	$l=strripos($feed, ".");
	if($l !== false)
		$ext = strtolower(substr($feed, $l));

	if(! in_array($ext, array(".xml", ".rss", ".atom", ".rdf", ".feed")))
		die("Bad extension in feed filename");

logMessage("feed=$feed\n");

	$myfeed = new Ara();
	$title= stripslashes($title);
	$detected = mb_detect_encoding($title);
	$title = mb_convert_encoding($title, "UTF-8", $detected);
	
	$detected = mb_detect_encoding($desc);
	$desc = mb_convert_encoding($desc, "UTF-8", $detected);
	$desc = stripslashes($desc);
	$myfeed->ARAFeed($title, $link, $desc, $date);	

	// processing other parameters
	foreach($posted as $key => $value)
	{

		if(strlen($key) < 4) continue;		// unknown
		
		$key = substr($key, 0, 4);
		
		if(strcasecmp($key, "titl") == 0) 	
		{
			$title = stripslashes($value);
			$detected = mb_detect_encoding($title);
			$title = mb_convert_encoding($title, "UTF-8", $detected);
			continue;
		}	

		if(strcasecmp($key, "link") == 0) 	
		{
			$link = $value;
			continue;
		}	
		if(strcasecmp($key, "desc") == 0) 	
		{
			$description = stripslashes($value);
			$detected = mb_detect_encoding($description);			
			$description = str_replace($unwanted, " ", $description);
			$description = mb_convert_encoding($description, "UTF-8", $detected);
			continue;
		}	
		if(strcasecmp($key, "date") == 0) 	
		{
			$date = $value;
			continue;
		}	
		
		if(strcasecmp($key, "type") == 0) 	
		{
			if($value != 1) continue;
			$myfeed->ARAItem($title, $link, $description, $date);
			continue;
		}	
	}

	$thisdir = getcwd();

logMessage("current directory=$thisdir\n");

	$ximage = $myfeed->saveXML();
	$xf = fopen($feed, "w");
	 
	if($xf != false)
	{
		fwrite($xf, $ximage);
		fclose($xf);
	  araMessage("$feed created");
	}
	else
	{
    araMessage("Enable to open $feed, NOT CREATED.");
  }


	header("Location:ara.php");


?>
